Package org.apache.sis.storage.event

## Class StoreListeners

- Object
- - WarningListeners
  - - StoreListeners

- All Implemented Interfaces:
    `Localized`

      public class StoreListeners
      extends WarningListeners
      implements Localized

  Holds a list of `StoreListener` instances and provides convenience methods for sending events. This is a helper class for `DataStore` and `Resource` implementations.

  Observers can add listeners for being notified about events, and producers can invoke one of the `warning(…)` and other methods for emitting events.

  Warning events
  All warnings are given to the listeners as `LogRecord` instances (this allows localizable messages and additional information like stack trace, timestamp, etc.). This `StoreListeners` class provides convenience methods like `warning(String, Exception)`, which build `LogRecord` from an exception or from a string. But all those `warning(…)` methods ultimately delegate to `warning(LogRecord)`, thus providing a single point that subclasses can override. When a warning is emitted, the default behavior is:
  - Notify all listeners registered for `WarningEvent` type in this `StoreListeners` and in the parent managers.
  - If previous step found no listener registered for `WarningEvent`, then log the warning in the first logger found in following choices:
    1. The logger specified by `LogRecord​.getLoggerName()` if non-null.
    2. Otherwise the logger specified by `DataStoreProvider​.getLogger()` if the provider can be found.
    3. Otherwise a logger whose name is the source `DataStore` package name.
  Thread safety
  The same `StoreListeners` instance can be safely used by many threads without synchronization on the part of the caller. Subclasses should make sure that any overridden methods remain safe to call from multiple threads.
  Since:
    1.0

  Defined in the `sis-storage` module

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `StoreListeners​(StoreListeners parent, Resource source)` | Creates a new instance with the given parent and initially no listener.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `<T extends StoreEvent> void` | `addListener​(Class<T> eventType, StoreListener<? super T> listener)` | Registers a listener to notify when the specified kind of event occurs.
    `void` | `addWarningListener​(WarningListener listener)` | Deprecated. Replaced by `addListener(listener, WarningEvent​.class)`.
    `<T extends StoreEvent> boolean` | `fire​(T event, Class<T> eventType)` | Sends the given event to all listeners registered for the given type or for a super-type.
    `Locale` | `getLocale()` | Returns the locale used by this manager, or `null` if unspecified.
    `Resource` | `getSource()` | Returns the source of events.
    `String` | `getSourceName()` | Returns a short name or label for the source.
    `boolean` | `hasListeners()` | Deprecated.
    `boolean` | `hasListeners​(Class<? extends StoreEvent> eventType)` | Returns `true` if this object or its parent contains at least one listener for the given type of event.
    `<T extends StoreEvent> void` | `removeListener​(Class<T> eventType, StoreListener<? super T> listener)` | Unregisters a listener previously added for the given type of events.
    `void` | `removeWarningListener​(WarningListener listener)` | Deprecated. Replaced by `removeListener(listener, WarningEvent​.class)`.
    `void` | `warning​(Exception exception)` | Reports a warning described by the given exception.
    `void` | `warning​(String message)` | Reports a warning described by the given message.
    `void` | `warning​(String message, Exception exception)` | Reports a warning described by the given message and exception.
    `void` | `warning​(Level level, String message, Exception exception)` | Reports a warning at the given level represented by the given message and exception.
    `void` | `warning​(LogRecord description)` | Reports a warning described by the given log record.

    - ### Methods inherited from class WarningListeners

      `getListeners, getLogger`

    - ### Methods inherited from class Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StoreListeners

          public StoreListeners​(StoreListeners parent,
                                Resource source)

      Creates a new instance with the given parent and initially no listener. The parent is typically the listeners of the `DataStore` that created a resource.
      Parameters:
        `parent` - the manager to notify in addition to this manager, or `null` if none.
        `source` - the source of events. Can not be null.

  - ### Method Detail

    - #### getSource

          public Resource getSource()

      Returns the source of events. This value is specified at construction time.
      Overrides:
        `getSource` in class `WarningListeners`
      Returns:
        the source of events.

    - #### getSourceName

          public String getSourceName()

      Returns a short name or label for the source. It may be the name of the file opened by a data store. The returned name can be useful in warning messages for identifying the problematic source.

      The default implementation fetches that name from the data store, or returns an arbitrary name if it can get it otherwise.

      Returns:
        a short name of label for the source (never `null`).
      See Also:
        `DataStore​.getDisplayName()`

    - #### getLocale

          public Locale getLocale()

      Returns the locale used by this manager, or `null` if unspecified. That locale is typically inherited from the `DataStore` locale and can be used for formatting messages.
      Specified by:
        `getLocale` in interface `Localized`
      Overrides:
        `getLocale` in class `WarningListeners`
      Returns:
        the locale for messages (typically specified by the data store), or `null` if unknown.
      See Also:
        `DataStore​.getLocale()`, `StoreEvent​.getLocale()`

    - #### warning

          public void warning​(String message)

      Reports a warning described by the given message.

      This method is a shortcut for `warning(Level​.WARNING, message, null)`.

      Parameters:
        `message` - the warning message to report.

    - #### warning

          public void warning​(Exception exception)

      Reports a warning described by the given exception. The exception stack trace will be omitted at logging time for avoiding to pollute console output (keeping in mind that this method should be invoked only for non-fatal warnings). See below for more explanation.

      This method is a shortcut for `warning(Level​.WARNING, null, exception)`.

      Parameters:
        `exception` - the exception to report.

    - #### warning

          public void warning​(String message,
                              Exception exception)

      Reports a warning described by the given message and exception. At least one of `message` and `exception` arguments shall be non-null. If both are non-null, then the exception message will be concatenated after the given message. If the exception is non-null, its stack trace will be omitted at logging time for avoiding to pollute console output (keeping in mind that this method should be invoked only for non-fatal warnings). See below for more explanation.

      This method is a shortcut for `warning(Level​.WARNING, message, exception)`.

      Overrides:
        `warning` in class `WarningListeners`
      Parameters:
        `message` - the warning message to report, or `null` if none.
        `exception` - the exception to report, or `null` if none.

    - #### warning

          public void warning​(Level level,
                              String message,
                              Exception exception)

      Reports a warning at the given level represented by the given message and exception. At least one of `message` and `exception` arguments shall be non-null. If both are non-null, then the exception message will be concatenated after the given message.
      Stack trace omission
      If there is no registered listener for the `WarningEvent` type, then the `warning(LogRecord)` method will send the record to a logger but without the stack trace. This is done that way because stack traces consume lot of space in the logging files, while being considered implementation details in the context of `StoreListeners` (on the assumption that the logging message provides sufficient information). If the stack trace is desired, then users can either:
      - invoke `warning(LogRecord)` directly, or
      - override `warning(LogRecord)` and invoke `LogRecord​.setThrown(Throwable)` explicitly, or
      - register a listener which will log the record itself.
      Overrides:
        `warning` in class `WarningListeners`
      Parameters:
        `level` - the warning level.
        `message` - the message to log, or `null` if none.
        `exception` - the exception to log, or `null` if none.

    - #### warning

          public void warning​(LogRecord description)

      Reports a warning described by the given log record. The default implementation forwards the given record to one of the following destinations, in preference order:
      - `StoreListener​.eventOccured(new WarningEvent(source, record))` on all listeners registered for this kind of event.
      - Only if above step found no listener, then `Logging​.getLogger(record​.loggerName).log(record)` where `loggerName` is one of the following:
        - `record.getLoggerName()` if that value is non-null.
        - Otherwise the value of `DataStoreProvider​.getLogger()` if the provider is found.
        - Otherwise the source `DataStore` package name.
      Overrides:
        `warning` in class `WarningListeners`
      Parameters:
        `description` - warning details provided as a log record.

    - #### fire

          public <T extends StoreEvent> boolean fire​(T event,
                                                     Class<T> eventType)

      Sends the given event to all listeners registered for the given type or for a super-type. This method first notifies the listeners registered in this `StoreListeners`, then notifies listeners registered in parent `StoreListeners`s. Each listener will be notified only once even if it has been registered many times.
      Type Parameters:
        `T` - compile-time value of the `eventType` argument.
      Parameters:
        `event` - the event to fire.
        `eventType` - the type of events to be fired.
      Returns:
        `true` if the event has been sent to at least one listener.

    - #### addListener

          public <T extends StoreEvent> void addListener​(Class<T> eventType,
                                                         StoreListener<? super T> listener)

      Registers a listener to notify when the specified kind of event occurs. Registering a listener for a given `eventType` also register the listener for all event sub-types. The same listener can be registered many times, but its `StoreListener​.eventOccured(StoreEvent)` method will be invoked only once per event. This filtering applies even if the listener is registered on different resources in the same tree, for example a parent and its children.
      Warning events
      If `eventType` is assignable from `WarningEvent.class`, then registering that listener turns off logging of warning messages for this manager. This side-effect is applied on the assumption that the registered listener will handle warnings in its own way, for example by showing warnings in a widget.
      Type Parameters:
        `T` - compile-time value of the `eventType` argument.
      Parameters:
        `eventType` - type of `StoreEvent` to listen (can not be `null`).
        `listener` - listener to notify about events.
      See Also:
        `Resource​.addListener(Class, StoreListener)`

    - #### removeListener

          public <T extends StoreEvent> void removeListener​(Class<T> eventType,
                                                            StoreListener<? super T> listener)

      Unregisters a listener previously added for the given type of events. The `eventType` must be the exact same class than the one given to the `addListener(…)` method; this method does not remove listeners registered for subclasses and does not remove listeners registered in parent manager.

      If the same listener has been registered many times for the same even type, then this method removes only the most recent registration. In other words if `addListener(type, ls)` has been invoked twice, then `removeListener(type, ls)` needs to be invoked twice in order to remove all instances of that listener. If the given listener is not found, then this method does nothing (no exception is thrown).

      Warning events
      If `eventType` is `WarningEvent.class` and if, after this method invocation, there is no remaining listener for warning events, then this `StoreListeners` will send future warnings to the loggers.
      Type Parameters:
        `T` - compile-time value of the `eventType` argument.
      Parameters:
        `eventType` - type of `StoreEvent` which were listened (can not be `null`).
        `listener` - listener to stop notifying about events.
      See Also:
        `Resource​.removeListener(Class, StoreListener)`

    - #### hasListeners

          public boolean hasListeners​(Class<? extends StoreEvent> eventType)

      Returns `true` if this object or its parent contains at least one listener for the given type of event.
      Parameters:
        `eventType` - the type of event for which to check listener presence.
      Returns:
        `true` if this object contains at least one listener for given event type, `false` otherwise.

    - #### hasListeners

          @Deprecated
          public boolean hasListeners()

      Deprecated.
      Returns `true` if this object contains at least one listener.
      Overrides:
        `hasListeners` in class `WarningListeners`
      Returns:
        `true` if this object contains at least one listener, `false` otherwise.

    - #### addWarningListener

          @Deprecated
          public void addWarningListener​(WarningListener listener)

      Deprecated.
      Replaced by `addListener(listener, WarningEvent​.class)`.
      Description copied from class: `WarningListeners`
      Adds a listener to be notified when a warning occurred. When a warning occurs, there is a choice:
      - If this object has no warning listener, then the warning is logged at `Level​.WARNING`.
      - If this object has at least one warning listener, then all listeners are notified and the warning is not logged by this object.
      Overrides:
        `addWarningListener` in class `WarningListeners`
      Parameters:
        `listener` - the listener to add.

    - #### removeWarningListener

          @Deprecated
          public void removeWarningListener​(WarningListener listener)

      Deprecated.
      Replaced by `removeListener(listener, WarningEvent​.class)`.
      Description copied from class: `WarningListeners`
      Removes a previously registered listener.
      Overrides:
        `removeWarningListener` in class `WarningListeners`
      Parameters:
        `listener` - the listener to remove.